#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$30/10/2010'
#
# My-Weather-Indicator
# An indicator to show the weather
#
# Adding keybiding
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import os
import gobject
import gtk
import appindicator
import urllib2
import pynotify
import locale
import gettext
import glib
import time
import preferences
import dbus
import time
import webbrowser
from datetime import datetime
from forecastw import FC
from preferences import CM
from preferences import load_key
from preferences import is_key
import commwi
import goweapi
from configurator import GConf
from encoderapi import Encoder

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(commwi.APP, commwi.LANGDIR)
gettext.textdomain(commwi.APP)
_ = gettext.gettext

IDIOMA = locale.getlocale()[0][:2]

encoder = Encoder()

class MWI():	
	def __init__(self):
		if dbus.SessionBus().request_name('es.atareao.MyWeatherIndicator') != dbus.bus.REQUEST_NAME_REPLY_PRIMARY_OWNER:
			print "application already running"
			exit(0)		
		while is_key('latitude') == False or is_key('longitude') == False or is_key('location') == False or is_key('temperature') == False:
				p=preferences.CM()
				p.run()
				p.destroy()
		#
		self.latitude = load_key('latitude','39.361346')
		self.longitude = load_key('longitude','-0.4126143')
		self.location = load_key('location','C')
		self.temperature = load_key('temperature','Silla, Spain')
		self.refresh_time = load_key('refresh_time',5)		
		self.show_temperature = load_key('show_temperature',True)
		self.notification_by_time = load_key('notification_by_time',False)
		self.notification_time = load_key('notification_time',5)
		self.notification_when_temperature = load_key('notification_when_temperature',True)
		self.notification_when_humidity = load_key('notification_when_humidity',True)
		self.notification_when_wind = load_key('notification_when_wind',True)
		self.notification_when_condition = load_key('notification_when_condition',True)
		#
		self.last_notification = 0
		self.current_conditions = None
		self.preferences_out = False
		self.forecast_out = False
		#
		self.indicator = appindicator.Indicator('My-Weather-Indicator', 'My-Weather-Indicator', appindicator.CATEGORY_APPLICATION_STATUS)
		#
		self.set_menu()
		#
		glib.timeout_add_seconds(int(self.refresh_time*60), self.work)
		
	def get_help_menu(self):
		help_menu =gtk.Menu()
		#		
		menu_project = gtk.MenuItem(_('Application Web...'))
		menu_help_online = gtk.MenuItem(_('Get help online...'))
		menu_translations = gtk.MenuItem(_('Translate this application...'))
		menu_bugs = gtk.MenuItem(_('Report a bug...'))
		menu_separator_help_menu=gtk.SeparatorMenuItem()
		menu_about=gtk.MenuItem(_('About'))
		#
		menu_project.connect('activate',self.on_menu_project_clicked)
		menu_help_online.connect('activate',self.on_menu_help_online_clicked)
		menu_translations.connect('activate',self.on_menu_translations_clicked)
		menu_bugs.connect('activate',self.on_menu_bugs_clicked)
		menu_about.connect('activate',self.menu_about_response)
		#
		menu_project.show()
		menu_help_online.show()
		menu_translations.show()
		menu_bugs.show()
		menu_separator_help_menu.show()
		menu_about.show()
		#
		help_menu.append(menu_project)
		help_menu.append(menu_help_online)
		help_menu.append(menu_translations)
		help_menu.append(menu_bugs)
		help_menu.append(menu_separator_help_menu)
		help_menu.append(menu_about)
		#
		help_menu.show()
		#
		return help_menu
		
	def on_menu_project_clicked(self,widget):
		webbrowser.open('https://launchpad.net/my-weather-indicator')
		
	def on_menu_help_online_clicked(self,widget):
		webbrowser.open('https://answers.launchpad.net/my-weather-indicator')
	
	def on_menu_translations_clicked(self,widget):
		webbrowser.open('https://translations.launchpad.net/my-weather-indicator')
	
	def on_menu_bugs_clicked(self,widget):
		webbrowser.open('https://bugs.launchpad.net/my-weather-indicator')
	
	def add(self, text = None, icon = None, conector_event = None, conector_action = None):
		if text != None and icon == None:
			menu_item = gtk.MenuItem(text)
		elif text == None and icon != None:
			menu_item = gtk.ImageMenuItem()
			image = gtk.Image()
			image.set_from_file(icon)
			menu_item.set_image(image)
		elif text != None and icon != None:
			menu_item = gtk.ImageMenuItem(text)
			image = gtk.Image()
			image.set_from_file(icon)
			menu_item.set_image(image)
			menu_item.set_always_show_image(True)
		elif icon == None:
			menu_item = gtk.MenuItem(text)
		else:
			menu_item = gtk.SeparatorMenuItem()
		if conector_event != None and conector_action != None:				
			menu_item.connect(conector_event,conector_action)
		menu_item.show()
		self.menu.append(menu_item)
		return menu_item
	
	def set_menu(self):
		self.menu = gtk.Menu()	
		#
		weather = goweapi.get_weather_from_google(latitude = float(self.latitude), longitude = float(self.longitude), hl = IDIOMA)
		temporal_current_conditions = weather['current_conditions']
		forecast = weather['forecasts']
		conditions_changed = False
		if len(temporal_current_conditions)!=0:
			if self.current_conditions == None \
			or (self.notification_when_temperature == True and (temporal_current_conditions['temp_c'] != self.current_conditions['temp_c']))\
			or (self.notification_when_humidity and (temporal_current_conditions['humidity'] != self.current_conditions['humidity'])) \
			or (self.notification_when_wind and (temporal_current_conditions['wind_condition'] != self.current_conditions['wind_condition'])) \
			or (self.notification_when_condition and (temporal_current_conditions['condition_en'] != self.current_conditions['condition_en'])):
				conditions_changed = True
			self.current_conditions = temporal_current_conditions
			########################################################
			self.add(text = _('Location')+': '+self.location)
			self.add(text = _('Temperature')+': '+cambia(self.current_conditions['temp_c'],self.temperature)+' º'+self.temperature)
			self.add(text = self.current_conditions['humidity'])
			self.add(text = _('Termical sensation')+': '+cambia(self.current_conditions['termical_sensation'],self.temperature)+' º'+self.temperature)
			self.add(text = _('Dew Point')+': '+cambia(self.current_conditions['dew_point'],self.temperature)+' º'+self.temperature)
			self.add(text = self.current_conditions['wind_condition'])
			self.add(text = self.current_conditions['condition'],icon = commwi.IMGDIR+self.current_conditions['status_image'])
			self.add()
			self.add(text = _('Sunrise')+': '+self.current_conditions['sunrise'],icon = commwi.IMGDIR+'sunny.png')
			self.add(text = _('Sunset')+': '+self.current_conditions['sunset'],icon = commwi.IMGDIR+'sunny_n.png')
			self.add()
			self.add(text = self.current_conditions['moon_phase'], icon = commwi.MOONDIR+self.current_conditions['moon_icon'])
			self.add()
			menu_forecast = self.add(text = _('Forecast'), conector_event = 'activate',conector_action = self.menu_forecast_response)
			menu_forecast.set_sensitive(not self.forecast_out)
			menu_preferences = self.add(text = _('Preferences'), conector_event = 'activate',conector_action = self.menu_set_preferences_response)
			menu_preferences.set_sensitive(not self.preferences_out)
			self.add(text = _('Refresh weather'), conector_event = 'activate',conector_action = self.menu_refresh_weather_response)
			self.add()
			menu_help = self.add(text =_('Help'))
			menu_help.set_submenu(self.get_help_menu())
			self.add()
			self.add(text = _('Exit'), conector_event = 'activate',conector_action = self.menu_exit_response)
			########################################################
			self.menu.show()
			self.indicator.set_menu(self.menu)
			if self.show_temperature == True:
				self.indicator.set_label(cambia(self.current_conditions['temp_c'],self.temperature)+' º'+self.temperature)
			else:
				self.indicator.set_label('')
			self.indicator.set_status (appindicator.STATUS_ACTIVE)
			self.indicator.set_icon(self.current_conditions['status_icon'])
			########################################################
			if self.notification_by_time == False and conditions_changed == True:
				msg = _('Conditions in')+' '+self.location+'\n'
				msg += _('Temperature')+': '+cambia(self.current_conditions['temp_c'],self.temperature)+' º'+self.temperature+'\n'
				msg += self.current_conditions['humidity']+'\n'
				msg += self.current_conditions['wind_condition']+'\n'			
				msg += self.current_conditions['condition']
				self.notification = pynotify.Notification ('My-Weather-Indicator',msg,commwi.IMGDIR+self.current_conditions['status_image'])
				self.notification.show()					

			if self.notification_by_time == True and (time.time()-self.last_notification) > self.notification_time*60:
				self.last_notification = time.time()
				msg = _('Conditions in')+' '+self.location+'\n'
				msg += _('Temperature')+': '+cambia(self.current_conditions['temp_c'],self.temperature)+' º'+self.temperature+'\n'
				msg += self.current_conditions['humidity']+'\n'
				msg += self.current_conditions['wind_condition']+'\n'			
				msg += self.current_conditions['condition']
				self.notification = pynotify.Notification ('My-Weather-Indicator',msg,commwi.IMGDIR+self.current_conditions['status_image'])
				self.notification.show()					
				
	def work(self):
		self.set_menu()
		return True
		
	def menu_forecast_response(self,widget):				
		self.forecast_out = True
		widget.set_sensitive(False)
		fc = FC()
		widget.set_sensitive(True)				
		self.forecast_out = False

	def menu_set_preferences_response(self,widget):
		self.preferences_out = True
		widget.set_sensitive(False)
		p=preferences.CM()
		while is_key('latitude') == False or is_key('longitude') == False or is_key('location') == False or is_key('temperature') == False:
				p=preferences.CM()
		self.latitude = load_key('latitude','39.361346')
		self.longitude = load_key('longitude','-0.4126143')
		self.location = load_key('location','C')
		self.temperature = load_key('temperature','Silla, Spain')
		self.refresh_time = load_key('refresh_time',5)
		self.show_temperature = load_key('show_temperature',True)		
		self.notification_by_time = load_key('notification_by_time',False)
		self.notification_time = load_key('notification_time',5)
		self.notification_when_temperature = load_key('notification_when_temperature',True)
		self.notification_when_humidity = load_key('notification_when_humidity',True)
		self.notification_when_wind = load_key('notification_when_wind',True)
		self.notification_when_condition = load_key('notification_when_condition',True)
		widget.set_sensitive(True)
		self.preferences_out = False
		self.set_menu()
		
	def menu_refresh_weather_response(self,widget):
		self.set_menu()

	def menu_exit_response(self,widget):
		exit(0)

	def menu_about_response(self,widget):
		widget.set_sensitive(False)
		ad=gtk.AboutDialog()
		ad.set_name(commwi.APPNAME)
		ad.set_version(commwi.VERSION)
		ad.set_copyright('Copyrignt (c) 2011\nLorenzo Carbonell')
		ad.set_comments(_('A weather indicator'))
		ad.set_license(_(''+
		'This program is free software: you can redistribute it and/or modify it\n'+
		'under the terms of the GNU General Public License as published by the\n'+
		'Free Software Foundation, either version 3 of the License, or (at your option)\n'+
		'any later version.\n\n'+
		'This program is distributed in the hope that it will be useful, but\n'+
		'WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY\n'+
		'or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for\n'+
		'more details.\n\n'+
		'You should have received a copy of the GNU General Public License along with\n'+
		'this program.  If not, see <http://www.gnu.org/licenses/>.'))		
		ad.set_website('http://www.atareao.es')
		ad.set_website_label('http://www.atareao.es')
		ad.set_authors(['Pascal De Vuyst <pascal.devuyst@gmail.com>','Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_translator_credits('Antoni Sperka <https://launchpad.net/~antek1004-gmail>\n\
Clemente Junior <https://launchpad.net/~clmnt-jr>\n\
David Štancl <https://launchpad.net/~dstancl-dstancl>\n\
Fabio Lambertini <https://launchpad.net/~fabio-lambe>\n\
Fitoschido <fitoschido@gmail.com>\n\
Giorgio Grappa <https://launchpad.net/~j-monteagudo>\n\
Jiri Grönroos <https://launchpad.net/~jiri-gronroos>\n\
Lorenzo Carbonell <https://launchpad.net/~lorenzo-carbonell>\n\
NykO18 <https://launchpad.net/~nyko18>\n\
Pascal De Vuyst <pascal.devuyst@gmail.com>\n\
R33D3M33R <https://launchpad.net/~r33d3m33r>\n\
Xose M Lamas <https://launchpad.net/~xmgz>\n\
zeugma <https://launchpad.net/~sunder67>')
		ad.set_documenters(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_logo(gtk.gdk.pixbuf_new_from_file(commwi.ICON))
		ad.set_icon(gtk.gdk.pixbuf_new_from_file(commwi.ICON))
		ad.set_program_name(commwi.APPNAME)
		ad.run()
		ad.destroy()
		widget.set_sensitive(True)

def redondea(valor):
	valor = valor * 10.0
	return int(valor)/10.0

def cambia(valor,a):
	if len(valor)==0:
		return ''
	valor = float(valor)
	if a=='F':
		return str(redondea(valor*9.0/5.0 + 32.0))
	elif a == 'K':
		return str(redondea(valor+273.15))
	return str(valor)

if __name__ == "__main__":
	mwi=MWI()
	gtk.main()
