#! /usr/bin/python
# -*- coding: iso-8859-1 -*-
#
__author__="atareao"
__date__ ="$29-ene-2011$"
#
# <from numbers to letters.>
#
# Copyright (C) 2011 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import os
import shutil
import gtk
import locale
import gettext
import commwi
import geocodeapi
from searchlocation import SL
from configurator import GConf

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(commwi.APP, commwi.LANGDIR)
gettext.textdomain(commwi.APP)
_ = gettext.gettext

APPDIR = commwi.APPDIR

ROOT = '/apps/my-weather-indicator/options/'

def is_key(key):
	gconfi = GConf()
	PATH = ROOT+key
	valor = gconfi.get_key(PATH)
	if valor == None:
		return False
	return True

def load_key(key,defecto):
	gconfi = GConf()
	PATH = ROOT+key
	try:
		valor = gconfi.get_key(PATH)
		if valor == None:
			gconfi.set_key(PATH,defecto)
			return defecto
		return valor
	except ValueError:
		gconfi.set_key(PATH,defecto)
	return defecto


class CM(gtk.Dialog): # needs GTK, Python, Webkit-GTK
	def __init__(self):
		self.location = None
		#***************************************************************
		gtk.Dialog.__init__(self,'my-weather-indicator | '+_('Preferences'),None,gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,(gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT,gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
		self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		self.set_size_request(450, 450)
		self.connect('destroy', self.close_application)
		self.set_icon_from_file(commwi.ICON)
		#***************************************************************
		vbox = gtk.VBox(spacing = 5)
		vbox.set_border_width(5)
		self.get_content_area().add(vbox)
		#***************************************************************
		notebook = gtk.Notebook()
		vbox.add(notebook)
		#***************************************************************
		#***************************************************************
		vbox1 = gtk.VBox(spacing = 5)
		vbox1.set_border_width(5)
		table1 = gtk.Table(rows = 2, columns = 3)
		vbox1.pack_start(table1,True,True)
		notebook.append_page(vbox1,tab_label=gtk.Label('Ubication'))
		#***************************************************************
		label1 = gtk.Label(_('Latitude')+':')
		label1.set_alignment(xalign=0, yalign=0.5)
		table1.attach(label1,0,1,0,1,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#
		self.entry1 = gtk.Entry()
		table1.attach(self.entry1,1,2,0,1,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		label2 = gtk.Label(_('longitude')+':')
		label2.set_alignment(xalign=0, yalign=0.5)
		table1.attach(label2,0,1,1,2,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#
		self.entry2 = gtk.Entry()
		table1.attach(self.entry2,1,2,1,2,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		button0 = gtk.Button(_('Search Location'))		
		button0.connect('clicked',self.search_location)
		table1.attach(button0,2,3,0,2,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		#***************************************************************
		vbox2 = gtk.VBox(spacing = 5)
		vbox2.set_border_width(5)
		table2 = gtk.Table(rows = 2, columns = 2)
		vbox2.pack_start(table2,True,True)
		notebook.append_page(vbox2,tab_label=gtk.Label(_('Temperature')))
		#***************************************************************
		label3 = gtk.Label(_('Temperature')+':')
		label3.set_alignment(xalign=0, yalign=0.5)
		table2.attach(label3,0,1,0,1,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		self.liststore3 = gtk.ListStore(str,str)
		self.liststore3.append([_('Celsius'),'C'])
		self.liststore3.append([_('Fahrenheit'),'F'])
		self.liststore3.append([_('Kelvin'),'K'])
		self.combobox3 = gtk.ComboBox(self.liststore3)
		cell3 = gtk.CellRendererText()
		self.combobox3.pack_start(cell3, True)
		self.combobox3.add_attribute(cell3, 'text', 0)  
		table2.attach(self.combobox3,1,2,0,1,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		self.checkbutton2 = gtk.CheckButton(_('Show temperature'))		
		table2.attach(self.checkbutton2,0,2,1,2,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)	
		#***************************************************************		
		#***************************************************************		
		vbox3 = gtk.VBox(spacing = 5)
		vbox3.set_border_width(5)
		table3 = gtk.Table(rows = 2, columns = 2)
		vbox3.pack_start(table3,True,True)
		notebook.append_page(vbox3,tab_label=gtk.Label(_('General options')))
		#***************************************************************
		self.checkbutton1 = gtk.CheckButton(_('Autostart'))		
		table3.attach(self.checkbutton1,0,2,0,1,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		label4 = gtk.Label(_('Refresh time')+(' (min):'))
		label4.set_alignment(xalign=0, yalign=0.5)
		table3.attach(label4,0,1,1,2,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		self.spinbutton1 = gtk.SpinButton()
		self.spinbutton1.set_range(5,600)
		self.spinbutton1.set_increments(5,10)
		table3.attach(self.spinbutton1,1,2,1,2,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		#***************************************************************		
		vbox4 = gtk.VBox(spacing = 5)
		vbox4.set_border_width(5)
		table4 = gtk.Table(rows = 4, columns = 2)
		vbox4.pack_start(table4,True,True)
		notebook.append_page(vbox4,tab_label=gtk.Label(_('Notifications')))
		#***************************************************************
		self.optionbutton41 = gtk.RadioButton(None,_('Notification by time'))		
		self.optionbutton41.connect('toggled',self.on_optionbutton41_toggled)
		table4.attach(self.optionbutton41,0,2,0,1,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		self.frame41 = gtk.Frame()
		table4.attach(self.frame41,0,2,1,2,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		hbox41 = gtk.HBox(spacing = 5)
		hbox41.set_border_width(5)
		self.frame41.add(hbox41)
		#***************************************************************
		label41 = gtk.Label(_('Time between notifications')+' (min): ')
		hbox41.pack_start(label41,True,True)
		self.spinbutton2 = gtk.SpinButton()
		self.spinbutton2.set_range(5,600)
		self.spinbutton2.set_increments(5,10)
		hbox41.pack_start(self.spinbutton2,True,True)
		#***************************************************************
		self.optionbutton42 = gtk.RadioButton(self.optionbutton41,_('Notification when ...'))		
		self.optionbutton42.connect('toggled',self.on_optionbutton42_toggled)
		table4.attach(self.optionbutton42,0,2,2,3,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		self.frame42 = gtk.Frame()
		table4.attach(self.frame42,0,2,3,4,xoptions=gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		vbox42 = gtk.VBox(spacing = 5)
		vbox42.set_border_width(5)
		self.frame42.add(vbox42)
		self.frame42.set_sensitive(False)
		#***************************************************************
		'''
		or temporal_current_conditions['temp_c'] != self.current_conditions['temp_c'] \
		or temporal_current_conditions['humidity'] != self.current_conditions['humidity'] \
		or temporal_current_conditions['wind_condition'] != self.current_conditions['wind_condition'] \
		or temporal_current_conditions['condition'] != self.current_conditions['condition'] \
		or temporal_current_conditions['icon'] != self.current_conditions['icon']:
		'''
		self.option421 = gtk.CheckButton(_('temperatura changes'))
		vbox42.pack_start(self.option421,True,True)
		self.option422 = gtk.CheckButton(_('humidity changes'))
		vbox42.pack_start(self.option422,True,True)
		self.option423 = gtk.CheckButton(_('wind condition changes'))
		vbox42.pack_start(self.option423,True,True)
		self.option424 = gtk.CheckButton(_('condition changes'))
		vbox42.pack_start(self.option424,True,True)
		#***************************************************************
		#***************************************************************				
		if os.path.exists(os.path.join(os.getenv("HOME"),".config/autostart/my-weather-indicator-autostart.desktop")):
			self.checkbutton1.set_active(True)
		#
		self.show_all()
		#
		self.load_preferences()
		#
		if self.run() == gtk.RESPONSE_ACCEPT:
			if self.location == None:
				direction = geocodeapi.get_inv_direction(self.entry1.get_text(),self.entry2.get_text())
				if direction['locality'] != None:
					self.location = direction['locality']+', '+direction['country']
				else:
					self.location = direction['country']			
			self.save_preferences()
			filestart = os.path.join(os.getenv("HOME"),".config/autostart/my-weather-indicator-autostart.desktop")
			if self.checkbutton1.get_active():
				if not os.path.exists(filestart):
					shutil.copyfile('/usr/share/my-weather-indicator/my-weather-indicator-autostart.desktop',filestart)
			else:		
				if os.path.exists(filestart):
					os.remove(filestart)
			self.ok = True
		else:
			self.ok = False
		self.destroy()
		
	def on_optionbutton41_toggled(self,widget):
		self.frame41.set_sensitive(widget.get_active())		

	def on_optionbutton42_toggled(self,widget):
		self.frame42.set_sensitive(widget.get_active())		
		
	def close_application(self, widget):
		self.ok = False
		self.destroy()
		
	def search_location(self,widget):
		sl = SL(self,self.entry1.get_text(),self.entry2.get_text())
		if sl.run() == gtk.RESPONSE_ACCEPT:
			self.latitude = str(sl.get_latitude())
			self.longitude = str(sl.get_longitude())
			self.location = sl.get_location()
			self.entry1.set_text(self.latitude)
			self.entry2.set_text(self.longitude)
		else:
			self.latitude = None
			self.longitude = None
			self.location = None
		sl.destroy()

	def load_preferences(self):
		self.entry1.set_text(load_key('latitude','39.361346'))
		self.entry2.set_text(load_key('longitude','-0.4126143'))
		if load_key('show_temperature',True):
			self.checkbutton2.set_active(True)
		self.spinbutton1.set_value(load_key('refresh_time',5))
		self.temperature = load_key('temperature','C')
		if self.temperature == 'C':
			self.combobox3.set_active(0)
		elif self.temperature == 'F':
			self.combobox3.set_active(1)
		elif self.temperature == 'K':
			self.combobox3.set_active(2)
		self.optionbutton41.set_active(load_key('notification_by_time',False))
		self.spinbutton2.set_value(load_key('notification_time',5))
		self.optionbutton42.set_active(not load_key('notification_by_time',False))
		self.option421.set_active(load_key('notification_when_temperature',True))
		self.option422.set_active(load_key('notification_when_humidity',True))
		self.option423.set_active(load_key('notification_when_wind',True))
		self.option424.set_active(load_key('notification_when_condition',True))
		
	def save_preferences(self):
		gconfi = GConf()	
		gconfi.set_key('/apps/my-weather-indicator/options/latitude',self.entry1.get_text())
		gconfi.set_key('/apps/my-weather-indicator/options/longitude',self.entry2.get_text())
		gconfi.set_key('/apps/my-weather-indicator/options/temperature',self.liststore3.get_value(self.combobox3.get_active_iter(),1))
		gconfi.set_key('/apps/my-weather-indicator/options/location',self.location)
		gconfi.set_key('/apps/my-weather-indicator/options/show_temperature',self.checkbutton2.get_active())
		gconfi.set_key('/apps/my-weather-indicator/options/refresh_time',self.spinbutton1.get_value())
		gconfi.set_key('/apps/my-weather-indicator/options/notification_by_time',self.optionbutton41.get_active())
		gconfi.set_key('/apps/my-weather-indicator/options/notification_time',self.spinbutton2.get_value())
		gconfi.set_key('/apps/my-weather-indicator/options/notification_when_temperature',self.option421.get_active())
		gconfi.set_key('/apps/my-weather-indicator/options/notification_when_humidity',self.option422.get_active())
		gconfi.set_key('/apps/my-weather-indicator/options/notification_when_wind',self.option423.get_active())
		gconfi.set_key('/apps/my-weather-indicator/options/notification_when_condition',self.option424.get_active())
		
if __name__ == "__main__":	
	cm = CM()
	exit(0)
